#define NOFOOTER

#ifdef BURUNDUK
#  include "my_testlib.h"
#else
#  include "testlib.h"
#endif

#include <string>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define sz(v) (int)(v).size()

typedef long long ll;
                    
#define CHECK(f, a) { if (!(a)) quitf(f, #a); }
#define ASSERT(a) CHECK(_fail, a)

#ifdef _WIN32
#  define I64 "%I64d"
#else
#  define I64 "%Ld"
#endif

string str( int x )
{
  char buf[99];
  sprintf(buf, "%d", x);
  return string(buf);
}

int main(int argc, char *argv[])
{
  registerTestlibCmd(argc, argv);

  int pos = 0;
  vector <long long> v;

  while (!ans.seekEof())
  {
    long long a = ouf.readLong();
    long long b = ans.readLong();
    pos++;
    if (a != b)
      quitf(_wa, "pos = %d : " I64 " != " I64, pos, a, b);

    v.push_back(a);
  }
  if (pos == 0)
    quitf(_ok, "file is empty");
  quitf(_ok, "OK (n = %d)", pos);
  return 0;
}
