
#ifdef BURUNDUK
#  include "my_testlib.h"
#else
#  include "testlib.h"
#endif

#include <set>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef pair <int, int> pii;

const int N = (int)2e5;
const int C = (int)1e9;

set <pii> s;

int main(int, char *[])
{
  registerValidation();

  int w = inf.readInt(0, C);
  inf.readSpace();
  int h = inf.readInt(0, C);
  inf.readEoln();
  int n = inf.readInt(0, N);
  inf.readEoln();
  forn(i, n)
  {
    int x = inf.readInt(0, w);
    inf.readSpace();
    int y = inf.readInt(0, h);
    inf.readEoln();
    ensure(s.insert(pii(x, y)).second);
  }

  inf.readEof();
  return 0;
}
