
#define NOFOOTER

#include "testlib.h"

#include <string>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef long long ll;
                    
int main(int argc, char *argv[])
{
  registerTestlibCmd(argc, argv);

  int pos = 0, cnt = 0;

  string INF = "Infinite";
  const char *yn[] = {"YES", "NO"};
  while (!ans.seekEof())
  {
    pos++;
    string ca = ouf.readString();
    string ja = ans.readString();
    if ((ca == INF) != (ja == INF))
      quitf(_wa, "pos %d: contestant say %s, jury say %s", pos, yn[ca == INF], yn[ja == INF]);
    if (ca == INF)
      continue;
    cnt++;

    double a, b;
    if (sscanf(ca.c_str(), "%lf", &a) != 1) quitf(_pe, "can not parse double");
    if (sscanf(ja.c_str(), "%lf", &b) != 1) quitf(_fail, "can not parse double");
    if (fabs(a - b) > 1.1e-6)
      quitf(_wa, "pos = %d: contestant(%.10f) != jury(%.10f)", pos, a, b);
  }
  if (pos == 0)
    quitf(_ok, "file is empty");

  quitf(_ok, "OK (n = %d, yes = %d, no = %d)", pos, cnt, pos - cnt);
  return 0;
}
