#include <cstdio>
#include <algorithm>

using namespace std;

#include "random.h"

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

int main( int argc, char *argv[] )
{
  if (argc < 3)
  {
    puts("Usage: <seed for random> <n>");
    puts("  [seed == 0] => Time()");
    return 1;
  }

  int seed = atoi(argv[1]);
  int n = atoi(argv[2]);
  initrand(seed ? seed : Time());

  int q = 20000;
  forn(i, n)
    if (i < q)
      printf("wall %d %d %d %d\n", -10000, 10000 - i / 2, 10000, 10000 - (i + 1) / 2);
    else if (i + 1 < n)
      printf("shot %d %d\n", R(-10, 10), R(10, 10000));
    else
      puts("end");
  return 0;
}
