#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second


const int maxn = 100005;

int a[maxn], d[maxn], s[maxn];

int find(int v)
{
	if (d[v] == v)
		return v;
	return d[v] = find(d[v]);
}

void unite(int x, int y)
{
	int i = find(x);
	int j = find(y);
	if (i != j)
	{
		if (rand() & 1)
			swap(i, j);
		d[i] = j;
		s[j] += s[i];
	}
}

int main()
{
	//freopen("a.in", "r", stdin);
	int n;
	scanf("%d", &n);

	vector < pair < int, int > > v;
	for (int i = 0; i < n; i++)
	{
		int x;
		scanf("%d", &x);
		v.pb(mp(x, i));
	}

	sort(v.begin(), v.end());
	reverse(v.begin(), v.end());

	ll ans = 0;

	for (int i = 0; i < n; i++) d[i] = i, s[i] = 1;

	for (int i = 0; i < n; i++)
	{
		int p = v[i].snd;
		ll x = v[i].fst;

		ans += x;

		if (p && a[p - 1] && p + 1 < n && a[p + 1])
			ans += x * s[find(p - 1)] * s[find(p + 1)];

		a[p] = 1;
		
		if (p && a[p - 1])
		{
			ans += x * s[find(p - 1)];
			unite(p, p - 1);
		}
		if (p + 1 < n && a[p + 1])
		{
			ans += x * s[find(p + 1)];
			unite(p, p + 1);
		}
		
	}
	

	cout << ans;


	return 0;
}