#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second


const int maxn = 300005;

int a[maxn];

struct blk
{
	int l, r;

	vector < pair < int, int > > d;

	void build()
	{
		for (int i = l; i <= r; i++)
			d.pb(mp(a[i], i));
		sort(d.begin(), d.end());
	}

	pair < blk*, blk* > split(int x)
	{
		blk *lb = new blk();
		blk *rr = new blk();

		lb->l = l;
		lb->r = l + x - 1;
		rr->l = l + x;
		rr->r = r;

		//lb->build();
		//rr->build();

		for (auto y : d)
			if (y.snd <= l + x - 1)
				lb->d.pb(y);
			else
				rr->d.pb(y);

		return mp(lb, rr);
	}

	int get(int x)
	{
		return upper_bound(d.begin(), d.end(), mp(x, (int)1e9)) - d.begin();
	}
};

const int sz = 700;

vector < blk* > b;
int t;

int c[maxn];

int n;



void build(int p)
{
	b.clear();

	int i = 0;
	while (i < p)
	{
		blk *x = new blk();
		x->l = i;

		i = min(p, i + sz);
		x->r = i - 1;

		x->build();
		b.pb(x);
	}

	n = p;
}

void rebuild()
{
	int p = 0;
	for (auto x : b)
	{
		for (int i = x->l; i <= x->r; i++)
			c[p++] = a[i];

		delete x;
	}

	for (int i = 0; i < p; i++)
		a[i] = c[i];
	
	build(p);
}

int split(int x)
{
	int was = 0;
	for (int i = 0; i < b.size(); i++)
	{
		blk *y = b[i];

		
		if (x == was)
			return i;


		int prv = was;

		was += y->r - y->l + 1;
		if (was - 1 < x)
			continue;

		auto res = y->split(x - prv);
		delete y;

		vector < blk* > tmp;
		for (int j = 0; j < i; j++)
			tmp.pb(b[j]);
		int ret = tmp.size() + 1;
		tmp.pb(res.fst);
		tmp.pb(res.snd);
		for (int j = i + 1; j < b.size(); j++)
			tmp.pb(b[j]);

		b = tmp;

		return ret;
	}

		return b.size();
}

void insert(int pos, int x)
{
	
	a[n++] = x;
	blk *y = new blk();
	y->l = n - 1;
	y->r = n - 1;
	y->build();
	
	
	int ind = split(pos);
	
	
	b.insert(b.begin() + ind, y);
	
}

void erase(int pos)
{
	int i = split(pos);
	split(pos + 1);

	b.erase(b.begin() + i);
}

int query(int l, int r, int x)
{
	int i = split(l);
	int j = split(r + 1);

	int res = 0;

	while (i < j)
	{
		res += b[i++]->get(x);
	}

	return res;
}


void gen()
{
	freopen("a.in", "w", stdout);
	cout << 100000 << endl;
	for (int i = 0; i < 100000; i++)
	{
		if (i)
			cout << " ";
		cout << rand();
	}
	cout << endl;
	for (int i = 0; i < 100000; i++)
	{
		int pos = rand() % (i + 1);
		int add = rand();
		cout << "+ " << pos << " " << add << endl;
	}
	exit(0);
}


int main()
{
	//gen();
	//freopen("a.in", "r", stdin);
	
	scanf("%d\n", &n);

	for (int i = 0; i < n; i++)
	{
		scanf("%d", a + i);
	}

	build(n);

	scanf("\n");

	char type;
	int g = 0;
	while (scanf("%c", &type) == 1)
	{
	//	cerr << g << endl;
		g++;
		if (type == '-')
		{
			int x;
			scanf("%d\n", &x);
			erase(x);
		}
		else if (type == '+')
		{
			int pos, x;
			scanf("%d %d\n", &pos, &x);
			insert(pos, x);
		}
		else 
		{
			int l, r, x;
			scanf("%d %d %d\n", &l, &r, &x);
			printf("%d\n", query(l, r, x));
		}

		if (b.size() > 3 * 700)
			rebuild();

		//cerr << b.size() << endl;
	}

	//cerr << (ld)clock() / CLOCKS_PER_SEC << endl;

	return 0;
}