#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <fstream>
#include <time.h>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

const int maxn = 200005;
int n;
vector < pair < int , int > > v;
int ansX = 0, ansY = 0;
multiset < int >  s2;
multiset < int > s1;
int X, Y;
bool used[maxn];

int getmaxsub()
{
	return *(s2.rbegin());
}

void stadd(int y)
{
	if (s1.find(y) != s1.end())
	{
		s1.insert(y);
		return;
	}
	s1.insert(y);
	multiset < int > :: iterator it = s1.find(y);
	it--;
	int yl = *it;
	it++; it++;
	int yr = *it;
	s2.erase(s2.find(yr - yl));
	s2.insert(y - yl);
	s2.insert(yr - y);
}

void stdelete(int y)
{
	if (s1.find(y) == s1.end())
		return;
	if (s1.count(y) > 1)
	{
		s1.erase(s1.find(y));
		return;
	}
	multiset < int > :: iterator it = s1.find(y);
	it--;
	int yl = *it;
	it++; it++;
	int yr = *it;
	s2.erase(s2.find(y - yl));
	s2.erase(s2.find(yr - y));
	s2.insert(yr - yl);

	s1.erase(s1.find(y));
}

bool check(int x, bool ch = false)
{
	s1.clear();
	s2.clear();
	s1.insert(0);
	s1.insert(Y);
	s2.insert(Y);
	int pl = 0;
	int pr = 0;
	for (int i = 0; i < v.size(); i++)
		used[i] = false;
	for (int i = 0; i < v.size(); i++)
		if (i == 0 || v[i].fst != v[i-1].fst)
		{
			if (v[i].fst + x > X)
				break;
			for (; pl < v.size() && v[i].fst >= v[pl].fst; pl++)
				if (used[pl])
					stdelete(v[pl].snd);
			pr = max(pr, pl);
			for (; pr < v.size() && v[pr].fst < v[i].fst + x; pr++)
			{
				stadd(v[pr].snd);
				used[pr] = true;
			}
			int p = getmaxsub();
			if (p >= x)
			{
				if (!ch)
					return true;
				ansX = v[i].fst;
				for (auto it = s1.begin(); it != s1.end(); it++)
					if (it != s1.begin())
					{
						auto it2 = it;
						it2--;
						if (*it - *it2 >= x)
						{
							ansY = *it2;
							return true;
						}
					}
			}
		}
		return false;
}

void brute()
{
	v.pb(mp(0, Y));
	v.pb(mp(X, Y));


	pair < int, pair < int, int > > ans = mp(0, mp(0, 0));

	for (pair < int, int > p1 : v)
		for (pair < int, int > p2 : v)
		{
			int x = min(p1.fst, p2.fst);
			int y = min(p1.snd, p2.snd);

			if (X == x || y == Y)
				continue;

		
			bool any = false;

			for (int a = 1; a < 100; a++)
			{
				for (pair < int, int > z : v)
				{
					if (x + a > X || y + a > Y)
						any = true;
					if (x < z.fst && z.fst < x + a && y < z.snd && z.snd < y + a)
						any = true;
				}

				if (!any)
					ans = min(ans, mp(-a, mp(x, y)));
			}


		}

	cout << -ans.fst << endl << ans.snd.fst << " " << ans.snd.snd << endl;
}

void gen()
{
	ofstream out("a.in");
	//freopen("a.in", "w", stdout);
	out << (int)1e9 << " " << (int)1e9 << endl;
	out << 100000 << endl;
	for (int i = 0; i < 100000; i++)
		out << (rand() % 100000) << " " << (rand() % 100000) << endl;
	out.close();
}

int main()
{
	srand(8798);
	//gen();
	//freopen("a.in", "r", stdin);
	cin >> X >> Y;
	v.pb(mp(X, 0));
	v.pb(mp(0, 0));
	cin >> n;
	
	for (int i = 1; i <= n; i++)
	{
		int x, y;
		scanf("%d %d", &x, &y);


		if (n > 99999 && rand() % 200000 > 180001)
			continue;
		v.pb(mp(x, y));
	}
	if (X == 0 ||  Y == 0)
	{
		cout << "0\n0 0\n";
		return 0;
	}
	sort(v.begin(), v.end());
	int l = 1, r = min(X, Y);
	while (l < r)
	{
		int c = (l + r + 1) / 2;
		if (check(c))
			l = c;
		else
			r = c - 1;
	}
	check(l, 1);
	cout << l << "\n" << ansX << " " << ansY << "\n";
	cerr << (ld)clock() / CLOCKS_PER_SEC << endl;
	//brute();
	return 0;
}