#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned int uint;

const double PI = 3.1415926535897932384626433832795;

const int maxn = (1<<24)+100;


uint a, b;
uint cur = 0;
uint nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

uint T[maxn];


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int m, q; scanf("%d%d", &m, &q);
	cin >> a >> b;
	forn(iter, m) {
		uint add = nextRand();
		uint l = nextRand();
		uint r = nextRand();
		if (l > r) swap(l, r);
		T[l] += add;
		T[r+1] -= add;
	}
	uint sm = 0;
	forn(i, maxn) {
		sm += T[i];
		T[i] = sm;
	}
	forn(i, maxn-1) T[i+1] += T[i];
	uint ans = 0;
	forn(iter, q) {
		uint l = nextRand();
		uint r = nextRand();
		if (l > r) swap(l, r);
		uint res = T[r];
		if (l) res -= T[l-1];
		ans += res;
	}
	cout << ans << "\n";
	return 0;
}
