#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
//#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int n; scanf("%d", &n);
	vector<int> a(n);
	forn(i, n) scanf("%d", &a[i]);
	vector<pii> v;
	forn(i, n) v.pb(mp(a[i], i));
	sort(ALL(v));
	set<int> st;
	st.insert(-1);
	st.insert(n);
	vector<int> L(n);
	vector<int> R(n);
	for (int i = 0; i < n; ) {
		int cur = v[i].X;
		int j = i;
		while (j < n && cur == v[j].X) {
			R[j] = *st.lower_bound(v[j].Y)-1;
			++j;
		}
		for (int k = i; k < j; ++k) {
			st.insert(v[k].Y);
		}
		for (int k = i; k < j; ++k) {
			set<int>::iterator it = st.find(v[k].Y);
			--it;
			L[k] = *it+1;
		}
		i = j;
	}
	ll ans = 0;
	forn(i, n) {
		int pos = v[i].Y;
		ll mult = (pos-L[i]+1) * (ll)(R[i]-pos+1);
		ans += mult*(ll)v[i].X;
	}
	cout << ans << "\n";
	return 0;
}
