#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ui unsigned int
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

unsigned int a, b;
unsigned int cur = 0;
int m, q;
unsigned int T[(1<<25) + 123];
ui add[(1<<25) + 123];

void Push(int v, int tl, int tr){
	if ( !add[v] ) return;
	T[v] += (tr-tl+1)*add[v];
	if ( tl != tr ){
		add[2*v] = add[2*v+1] += add[v];
	}
	add[v] = 0;
}

void update(int v, int tl,int tr, int l, int r, int val){
	Push(v, tl, tr);
	if ( l > tr || r < tl ) return;
	if ( l <= tl && tr <= r ){
		add[v] += val;
		Push(v, tl, tr);
		return; 
	}
	int mid = (tl + tr)/2;
	update(2*v, tl, mid, l, r, val);
	update(2*v+1, mid+1, tr, l, r, val);
	T[v] = T[2*v] + T[2*v+1];
}

unsigned int get(int v, int tl, int tr, int l, int r){
	Push(v, tl, tr);
	if ( l > tr || r < tl ) return 0;
	if ( l <= tl && tr <= r ){
		return T[v];
	}
	int mid = (tl + tr)/2;
	return get(2*v, tl, mid, l, r) + get(2*v+1, mid+1, tr, l, r);
}


unsigned int nextRand(){
	cur = cur*a + b;
	return cur >> 8;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	cin >>m>>q;
	cin >>a>>b;

	int sz = 1<<24;

	for (int i=0;i<m;i++){
		int add = nextRand();
		int l = nextRand();
		int r = nextRand();
		if ( l > r ) swap(l, r);
		update(1, 0, sz-1, l, r, add);	
	}

	unsigned int ans = 0;

	for (int i=0;i<q;i++){
		int l = nextRand();
		int r = nextRand();
		if ( l > r ) swap(l, r);
		ans += get(1, 0, sz-1, l, r);
	}
	
	cout <<ans<<endl;







	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
