#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ui unsigned int
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

unsigned int a, b;
unsigned int cur = 0;
int m, q;
unsigned int A[(1<<24) + 11], pr[1<<24];

unsigned int nextRand(){
	cur = cur*a + b;
	return cur >> 8;
}

unsigned int get(int l, int r) {
	ui ans = pr[r];
	if(l) ans -= pr[l-1];
	return ans;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	cin >>m>>q;
	cin >>a>>b;

	int sz = 1<<24;

	for (int i=0;i<m;i++){
		int add = nextRand();
		int l = nextRand();
		int r = nextRand();
		if ( l > r ) swap(l, r);
		A[l] += add;
		A[r+1] -= add;
	}

	unsigned int temp = 0;

	for(int i = 0; i < sz; i++) {
		temp += A[i];
		A[i] = temp;
	}

	pr[0] = A[0];
	for(int i = 1; i < sz; i++) pr[i] = pr[i-1] + A[i];

	unsigned int ans = 0;

	for (int i=0;i<q;i++){
		int l = nextRand();
		int r = nextRand();
		if ( l > r ) swap(l, r);
		ans += get(l, r);
	}
	
	cout <<ans<<endl;







	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
