#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
typedef long long LL;
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;

int a[maxn], n;
pair <int, int> t[maxn];

void upd(int v, int l, int r, int p, int x)
{
	if (l == r)
		t[v] = mp(x, p);
	else
	{
		int m = (l + r) >> 1;
		if (p <= m)
			upd(v + v, l, m, p, x);
		else
			upd(v + v + 1, m + 1, r, p, x);
		t[v] = min(t[v + v], t[v + v + 1]);
	}
}

pair <int, int> get(int v, int tl, int tr, int l, int r)
{
	if (l > r)
		return mp(inf, 0);
	if (tl == l && tr == r)
		return t[v];
	int m = (tl + tr) >> 1;
	return min(get(v + v, tl, m, l, min(r, m)), get(v + v + 1, m + 1, tr, max(m + 1, l), r));
}

LL calc(int l, int r)
{
	if (l > r)
		return 0;
	int p = get(1, 1, n, l, r).S;
	LL s = (p - l + 1) * (r - p + 1);
	return calc(l, p - 1) + calc(p + 1, r) + s * a[p];
}

int main()
{
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	cin >> n;

	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
		upd(1, 1, n, i, a[i]);
	}

	cout << calc(1, n) << "\n";

	return 0;
}
