#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<24;
const int inf = 1<<30;

int m, q, a, b, n;
unsigned int cur;
unsigned int t[N+1], s[N+1];

int nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	n = 1<<24;
	scanf("%d %d", &m, &q);
	scanf("%d %d", &a, &b);
	for (int i = 0; i < m; i++) {
		int add = nextRand();
		int l = nextRand();
		int r = nextRand();
		if (l > r) swap(l, r); l--;
		t[l] += add;
		t[r] -= add;
	}
	for (int i = 0, val = 0; i < n; i++) {
		val += t[i];
		s[i+1] = s[i] + val;
	}
	unsigned int sum = 0;
	for (int i = 0; i < q; i++) {
		int l = nextRand();
		int r = nextRand();
		if (l > r) swap(l, r); l--;
		sum += s[r]-s[l];
	}
	cout << sum;

	return 0;
}
