#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

const int maxn = (int)1e5 + 10;

int a[maxn],v[maxn],p[maxn];
int l[maxn],r[maxn];

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif
	int n;

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d",&a[i]);
	}

	int size = 0;

	for (int i = 0; i < n; i++) {
		while(size > 0 && v[size - 1] > a[i]) size--;
		if (size == 0) {
			l[i] = -1;
		} else {
			l[i] = p[size - 1];
		}		
		v[size] = a[i];
		p[size] = i;
		size++;
	}

	size = 0;

	for (int i = n - 1; i >= 0; i--) {
		while(size > 0 && v[size - 1] >= a[i]) size--;
		if (size == 0) {
			r[i] = n;
		} else {
			r[i] = p[size - 1];
		}
		v[size] = a[i];
		p[size] = i;
		size++;
	}

	ll res = 0;

	for (int i = 0; i < n; i++) {
		res += a[i] * 1LL * (r[i] - i) * (i - l[i]); 
	}

	cout << res << endl;

	return 0;
}