#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "c"

const int sn = 320;
//const int sn = 1;
int max_len;

struct block
{
	vector <int> a;
	vector <int> b;
	
	void init()
	{
		b = vector <int>(a);
		sort(b.begin(), b.end());
	}
	
};

vector <block> b;
int arr[300001];

void ins(int x, int val)
{
	int L = sz(b[0].a);
	int pos = 1;
	while (L < x)
	{
		L += sz(b[pos].a);
		++pos;
	}
	--pos;
	L -= sz(b[pos].a);
	int pos_in_block = x - L;
	assert(pos_in_block >= 0 && pos_in_block <= sz(b[pos].a));
	b[pos].a.insert(b[pos].a.begin() + pos_in_block, val);
	b[pos].init();
	max_len = max(max_len, sz(b[pos].a));
}

void del(int x)
{
	int L = 0;
	int pos = 0;
	while (L <= x)
	{
		L += sz(b[pos].a);
		++pos;
	}
	--pos;
	L -= sz(b[pos].a);
	int pos_in_block = x - L;
	assert(pos_in_block >= 0 && pos_in_block < sz(b[pos].a));
	b[pos].a.erase(b[pos].a.begin() + pos_in_block);
	b[pos].init();
}

int query(int L, int R, int BD)
{
	int l = 0;
	int ans = 0;
	for (int i = 0; i < sz(b); ++i)
	{
		int r = l + sz(b[i].a);
		if (R <= l || r <= L)
		{
		}
		else if (L <= l && r <= R)
		{
			ans += upper_bound(b[i].b.begin(), b[i].b.end(), BD) - b[i].b.begin();
		}
		else
		{
			for (int j = max(0, L - l); j < min(sz(b[i].a), R - l); ++j)
			{
				ans += (b[i].a[j] <= BD);
			}
		}
		l = r;
	}
	return ans;
}

void build()
{
//	cerr << "build\n";
	int cnt = 0;
	for (const auto &c: b)
	{
		for (int i = 0; i < sz(c.a); ++i)
			arr[cnt++] = c.a[i];
	}
	b.clear();
	max_len = 0;
	for (int i = 0; i < cnt; i += sn)
	{
		b.pb(block());
		for (int j = i; j < min(i + sn, cnt); ++j)
			b.back().a.pb(arr[j]);
		b.back().init();
		max_len = max(max_len, (int) b.back().a.size());
	}
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int n;
	cin >> n;
	b.pb(block());
	for (int i = 0; i < n; ++i)
	{
		int t;
		scanf("%d", &t);
		b[0].a.pb(t);
	}
	build();
	char tmp[3];
	while (true)
	{
		if (scanf("%s", tmp) != 1)
			break;
		if (tmp[0] == '-')
		{
			int id;
			scanf("%d", &id);
			del(id);
		}
		else if (tmp[0] == '+')
		{
			int id, val;
			scanf("%d%d", &id, &val);
			ins(id, val);
		}
		else if (tmp[0] == '?')
		{
			int l, r, val;
			scanf("%d%d%d", &l, &r, &val);
			cout << query(l, r + 1, val) << '\n';
		}
		else
			assert(false);
		if (max_len > 2 * sn + 1)
			build();
	}
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
