import java.math.BigInteger;
import java.util.Scanner;


public class Main {

	/**
	 * @param args
	 */
	static long a, b;
	static long cur;
	static int nextRand() {
		cur = cur*a + b;
		cur %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		int ret = (int) (cur >> 8);
		//System.out.println("rand "+ret);
		return ret;
	}
	
	static final int COUNT = 16777216;
	static int part = 4096;
	
	/*static final int COUNT = 16;
	static int part = 4;*/
	
	static long[] array = new long[COUNT];
	static long[] partsums = new long[COUNT];
	static long[] adds = new long[5000];
	
	static void add(long add, int l, int r) {
		if (l>r) {
			int t = l;
			l = r;
			r = t;
		}
		int l1 = (l / part);
		if (l%part != 0) {
			++l1;
		}
		int r1 = ((r+1) / part) - 1;
		for (int i=l1; i<=r1; ++i) {
			adds[i] += add;
			adds[i] %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		}
		for (int i=l; i<part*l1; ++i) {
			array[i] += add;
			array[i] %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		}
		
		for (int i=part*(r1+1); i<=r; ++i) {
			array[i] += add;
			array[i] %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		}
		
	}
	
	static long sum(int l, int r) {
		long res = 0;
		if (l>r) {
			int t = l;
			l = r;
			r = t;
		}
		int l1 = (l / part);
		if (l%part != 0) {
			++l1;
		}
		int r1 = ((r+1) / part) - 1;
		for (int i=l1; i<=r1; ++i) {
			//res += BigInteger.valueOf(adds[i]).multiply(BigInteger.valueOf(part)).mod(BigInteger.valueOf(( (long)Integer.MAX_VALUE + 1 ) * 2)).longValue();
			res += adds[i] * part;
			res %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		}

		//System.out.println(l1+" "+r1);
		if (l1 > r1) {
			for (int i=l; i<=r; ++i) {
				res += array[i] + adds[i/part];
				res %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
			}
			
			return res;
		}
		
		res += partsums[r1];
		res %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		if (l1 > 0) res -= partsums[l1-1];
		res %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		
		//System.out.println("res"+res);
		for (int i=l; i<part*l1; ++i) {
			res += array[i] + adds[i/part];
			res %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		}
		
		for (int i=part*(r1+1); i<=r; ++i) {
			res += array[i] + adds[i/part];
			res %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		}
		return res;
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int m = in.nextInt();
		int q = in.nextInt();
		a = in.nextInt();
		b = in.nextInt();
		for (int i=0;i<m;++i) add(nextRand(), nextRand(), nextRand());
		
		/*add(5, 1, 14);
		add(1, 7, 15);
		for (int i=0;i<16;++i) System.out.print(array[i]+" ");
		System.out.println();
		for (int i=0; i<4;++i) System.out.print(adds[i]+" ");
		System.out.println();*/
		
		for (int i=0;i<part;++i) {
			for (int j=0;j<part;++j) {
				partsums[i] += array[i*part+j];
				partsums[i] %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
			}
			
		}
		for (int i=1;i<part;++i) {
			partsums[i] += partsums[i-1];
		}
		
		long result = 0;
		for (int i=0;i<q;++i) {
			result += sum(nextRand(), nextRand());
			result %= ( (long)Integer.MAX_VALUE + 1 ) * 2;
		}
		System.out.println(result);
		
		//System.out.println(sum(0,7));
	}

}
