#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

const int INF = 1000100;

int n;
pair<int, int> a[100500];

const int shift = 1 << 17;

pair<int, int> tree[2][2 * shift + 5];

void update(int v, int side) {
	v += shift;
	tree[side][v].first = 1;
	tree[side][v].second = v - shift;
	v /= 2;
	while (v > 0) {
		tree[side][v] = tree[side][2 * v + side];
		if (tree[side][v].first < tree[side][2 * v + (1 - side)].first) {
			tree[side][v] = tree[side][2 * v + (1 - side)];
		}
		v /= 2;
	}
}

pair<int, int> rmq(int l, int r, int side) {
	if (l > r)
		return mp(-1, -1);
	if (l & 1) {
		pair<int, int> res = rmq(l + 1, r, side);
		if (res.first < tree[side][l].first || (res.first == tree[side][l].first && side == 0))
			res = tree[side][l];
		return res;
	}
	if (r & 1) {
		pair<int, int> res = tree[side][r - 1];
		pair<int, int> other = rmq(l, r - 1, side);
		if (res.first < other.first || (res.first == other.first && side == 0))
			res = other;
		return res;
	}
	return rmq(l / 2, r / 2, side);
}

pair<int, int> myrmq(int l, int r, int side) {
	return rmq(l + shift, r + shift, side);
}

void solve() {
	cin >> n;
	a[0].first = -INF;
	a[0].second = 0;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i].first;
		a[i].second = i;
	}
	a[n + 1].first = -INF;
	a[n + 1].second = n + 1;
	n += 2;
	sort(a, a + n);

	for (int i = 0; i < 2 * shift + 5; ++i) {
		tree[0][i].first = tree[1][i].first = -INF - 1;
		tree[0][i].second = tree[1][i].second = -1;
	}

	li ans = 0;

	for (int i = 0; i < n; ++i) {
		if (a[i].second != 0 && a[i].second != n - 1) {
			int lef = myrmq(0, a[i].second, 1).second;
			int rig = myrmq(a[i].second, n, 0).second;
			ans += 1LL * (a[i].second - lef) * (rig - a[i].second) * a[i].first;

			//cout << a[i].second << ' '<< lef << ' ' << rig << ' ' << (a[i].second - lef) * (rig - a[i].second)<< "\n";

		}
		update(a[i].second, 0);
		update(a[i].second, 1);
		//cout << a[i].second << endl;
	}


	cout << ans << "\n";

}