#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int unt;

const int MAXN = (1 << 24) + 1;
unt sum[MAXN + 1];

unt A, B;
unt cur = 0;

unt nextRand() {
	cur = cur * A + B;
	return cur >> 8;
}

int main() {
	freopen("fastadd.in", "rt", stdin);
	freopen("fastadd.out", "wt", stdout);
	int M, Q;
	cin >> M >> Q;
	cin >> A >> B;
	forn(i, M) {
		unt add = nextRand();
		unt l = nextRand();
		unt r = nextRand();
		//cerr << add << ' ' << l << ' ' << r << '\n';
		if (l > r) swap(l, r);
		sum[l] += add;
		sum[r + 1] -= add;
	}
	forn(j, 2) {
		forn(i, MAXN) sum[i + 1] += sum[i];
	}
	unt ans = 0;
	forn(i, Q) {
		unt l = nextRand();
		unt r = nextRand();
		if (l > r) swap(l, r);
		//cerr << l << ' ' << r << '\n';
		ans += sum[r] - (l == 0 ? 0 : sum[l - 1]);
	}
	cout << ans << '\n';
	return 0;
}
