#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

using namespace std;

typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;

int main() {
	freopen("minsum.in", "rt", stdin);
	freopen("minsum.out", "wt", stdout);
    int N;
    cin >> N;
    vector<pii> a(N);
    forn(i, N) {
        cin >> a[i].fi;
        a[i].se = i;
    }
    sort(all(a));
    set<int> u;
    u.insert(-1);
    u.insert(N);
    i64 ans = 0;
    forn(i, N) {
        int x = a[i].se;
		auto it = u.lower_bound(x);;
		int r = *it;
		int l = *(--it);
        ans += 1LL * a[i].fi * (x - l) * (r - x);
        u.insert(x);
    }
    cout << ans << '\n';
	return 0;
}
