#include <bits/stdc++.h>

using namespace std;

unsigned int a, b;
unsigned int cur = 0;
unsigned int nextRand()
{
    cur = cur * a + b;
    return cur >> 8;
}

const int MAXN = 1 << 24;
unsigned int sum[MAXN << 1], mod[MAXN];

void add(int a, int b, int c, int v = 1, int l = 0, int r = MAXN)
{
    if(r - l == 1)
    {
        sum[v] += c;
        return;
    }
    if(a <= l && r <= b)
    {
        mod[v] += c;
        sum[v] += (r - l) * c;
        return;
    }
    if(r <= a || b <= l)
        return;
    int m = (l + r) >> 1;
    add(a, b, c, v << 1, l, m);
    add(a, b, c, (v << 1) + 1, m, r);
    sum[v] += c * (min(b, r) - max(a, l));
}

unsigned int get(int a, int b, int v = 1, int l = 0, int r = MAXN)
{
    if(a <= l && r <= b)
        return sum[v];
    if(r <= a || b <= l)
        return 0;
    int m = (l + r) >> 1;
    return mod[v] * (min(b, r) - max(a, l)) + get(a, b, v << 1, l, m) + get(a, b, (v << 1) + 1, m, r);
}

main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int m, q;
    // cout << (sizeof(sum) + sizeof(mod) >> 20) << endl;
    cin >> m >> q;
    cin >> a >> b;
    int l, r, c;
    while(m--)
    {
        c = nextRand();
        l = nextRand();
        r = nextRand();
        if(l > r) swap(l, r);
        add(l, r + 1, c);
    }
    unsigned int sum = 0;
    while(q--)
    {
        l = nextRand();
        r = nextRand();
        if(l > r) swap(l, r);
        sum += get(l, r + 1);
    }
    cout << sum << "\n";

}
