#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 200100;
const int K = 270;

struct seg {
	vector<int> a;
	vector<int> s;
	seg(){}
	seg (const vector<int>& c) {
		a = c;
		s = c;
		sort(s.begin(), s.end());
	}
	seg(const vector<int> & A, const vector<int>& S) {
		a = A;
		s = S;
	}
	
	int fnd (int x) {
		return upper_bound(all(s), x) - s.begin();
	}
};

vector <seg*> t;

int split (int num, int pos) {
	if (pos == 0) {
		return num;
	}
	vector <int> l, r;
	int sz = t[num]->a.size();
	for (int i = 0; i < pos; ++i) {
		l.pb(t[num]->a[i]);
	}
	for (int i = pos; i < sz; ++i) {
		r.pb(t[num]->a[i]);
	}
	vector <int> &tek = ((pos < sz - pos)?(l):(r)), &big = t[num]->s;
	seg* sg = new seg(tek);
	vector <int> tek2;
	int t1 = 0, t2 = 0;
	for (t2 = 0; t2 < sz(big); ++t2) {
		if (t1 < sz(tek) && sg->s[t1] == big[t2]) {
			++t1;
		}
		else {
			tek2.pb(big[t2]);
		}
	}
	seg* sg2 = new seg((pos < sz - pos)?(r):(l), tek2);
	delete t[num];
	t[num] = sg;
	t.insert(t.begin() + num + 1, sg2);
	if (pos >= sz - pos) {
		swap(t[num], t[num + 1]);
	}
	return num + 1;
}

int split (int idx) {
	forn(i, t.size()) {
		if ((int)t[i]->a.size() > idx) {
			return split(i, idx); 
		} else {
			idx -= t[i]->a.size();	
		}
	}
	return (int)t.size();	
}

void erase (int i) {
	int idx = split(i);
	t[idx]->a.erase(t[idx]->a.begin());
	t[idx]->s = t[idx]->a;
	sort(t[idx]->s.begin(), t[idx]->s.end()); 
}

void insert (int i, int x) {
	int idx = split(i);
	t.insert(t.begin() + idx, new seg(vector<int>(1, x)));
}

int fnd (int l, int r, int x) {
	int idxl = split(l), idxr = split(r + 1);
	int sum = 0;
	for (int i = idxl; i < idxr; ++i) {
		sum += t[i]->fnd(x);		
	}
	return sum;
}

int r[N];
int sz;

void rebuild() {
	sz = 0;	
	forn(i, t.size()) {
		int sz1 = (int)t[i]->a.size();
		forn(j, sz1)
			r[sz++] = t[i]->a[j];
	}
	while (sz(t)) {
		delete t.back();
		t.pop_back();
	}
	for (int i = 0; i < sz; i += K) {
		vector <int> help;
		for (int j = i; j < sz && j < i + K; ++j) {
			help.pb(r[j]);
		}		
		t.pb(new seg(help));
	}
}

struct Input {
	int n;
	int m;
	int a[N];
	int tp[N];
	int l[N], r[N], x[N];
	int pos[N];
	
	bool read () {
		if (scanf ("%d", &n) != 1)
			return 0;
		forn(i, n)
			scanf ("%d", &a[i]);
		char c;
		string qwe;
		getline(cin, qwe);
		m = 0;
		while (scanf ("%c", &c) == 1) {
			debug(c);
			if (c == '-') {
				tp[m] = 1;
				scanf ("%d", &pos[m]);
			} else if (c == '+') {
				tp[m] = 0;
				scanf ("%d %d", &pos[m], &x[m]);
			} else {
				tp[m] = 2;
				scanf ("%d %d %d", &l[m], &r[m], &x[m]); 	
			}
			string qwe;
			getline(cin, qwe);
			m++;
		}	
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	vector <int> ans;
	
	void write () {
		forn(i, ans.size()) {
			printf ("%d\n", ans[i]);
		}
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

int kol;

struct Solution: Data {

	void solve () {
		kol = n;
		vector <int> help;
		forn(i, n)
			help.pb(a[i]);
		t.clear();
		t.pb(new seg(help));
		rebuild();
		forn(i, m) {
			if (tp[i] == 0) {
				insert(pos[i], x[i]);
				kol++; 
			} else if (tp[i] == 1) {
				erase(pos[i]);
				kol--;
			} else {
				debug(mp(mp(l[i], r[i]), x[i]));
				ans.pb(fnd(l[i], r[i], x[i]));
			}
			if ((double)t.size() > (3 * kol) / K) {
				rebuild();
			}	
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
