#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

const int MAXN = 100500;

int n;
ll arr[MAXN];
int pos[MAXN];
ll mval[MAXN];
int cnt = 0;
ll sum = 0ll;
ll csum = 0ll;

int
main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("minsum.in", "r", stdin); freopen("minsum.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		int cur;
		cin >> cur;
		arr[i] = cur;
	}
	cnt = 0;
	csum = 0ll;
	for (int i = 1; i <= n; ++i) {
		while (cnt > 0) {
			if (mval[cnt] >= arr[i]) {
				csum -= (pos[cnt] - pos[cnt - 1]) * mval[cnt];
				--cnt;
			} else {
				break;
			}
		}
		++cnt;
		pos[cnt] = i;
		mval[cnt] = arr[i];
		csum += (pos[cnt] - pos[cnt - 1]) * mval[cnt];
		sum += csum;
	}
	cout << sum << '\n';
	return 0;
}