#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 1 << 24;

unsigned int m, q, a, b;
unsigned int cur = 0;

unsigned int sum[N + 1];

unsigned int nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

void segmentAdd() {
	unsigned int add = nextRand(), l = nextRand(), r = nextRand();
	if (l > r)
		swap(l, r);
	sum[l] += add, sum[r + 1] -= add;
}

unsigned int getValue() {
	int l = nextRand(), r = nextRand();
	if (l > r)
		swap(l, r);
	return sum[r] - (l > 0 ? sum[l - 1] : 0);
}

int main() {
#ifdef LOCAL42
#define TASK "A"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	cin >> m >> q >> a >> b;
	for (int i = 0; i < m; i++) {
		segmentAdd();
	}
	for (int i = 1; i < N; i++) {
		sum[i] += sum[i - 1];
	}
	for (int i = 1; i < N; i++) {
		sum[i] += sum[i - 1];
	}
	unsigned int _sum = 0;
	for (int i = 0; i < q; i++) {
		_sum += getValue();
	}
	cout << _sum << endl;
	return 0;
}
