#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

typedef long long LL;
typedef LL ll;
typedef unsigned int uint;

typedef pair<int, int> pii;
const int kInf = 1000 * 1000 * 1000;

uint a, b;
uint cur = 0;
uint nextRand() {
  cur = cur * a + b;
  return cur >> 8;
}

const int N = (1 << 24);

uint mem[N + 10];

int main() {
  int m, q;
  cin >> m >> q >> a >> b;

  FOR(i, 0, m) {
    uint add = nextRand();
    int l = nextRand();
    int r = nextRand();
    if (l > r) swap(l, r);
    mem[l] += add;
    mem[r + 1] -= add;
  }
  FOR(i, 0, N) {
    mem[i + 1] += mem[i];
  }
  FOR(i, 0, N) {
    mem[i + 1] += mem[i];
  }
  uint sum = 0;
  FOR(i, 0, q) {
    int l = nextRand();
    int r = nextRand();
    if (l > r) swap(l, r);
    sum += mem[r];
    if (l) sum -= mem[l - 1];
  }

  cout << sum;

  return 0;
}