#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

unsigned int a, b, cur = 0;

unsigned int nextRand()
{
    cur = cur * a + b;
    return cur >> 8;
}

vector<unsigned int> sums;

unsigned int get(int l, int r)
{
    if(l == 0)
        return sums[r];
    return sums[r] - sums[l - 1];
}

int main() {
    ios_base::sync_with_stdio(false);
    int m, q;
    cin >> m >> q;
    cin >> a >> b;
    sums.assign((1 << 24) + 1, 0);
    forn(i, m)
    {
        unsigned int add = nextRand();
        int l = nextRand();
        int r = nextRand();
        if(l > r)
            swap(l, r);
        sums[l] += add;
        sums[r + 1] -= add;
    }
    unsigned int now = 0;
    forn(i, sums.size())
    {
        now += sums[i];
        sums[i] = now;
    }
    now = 0;
    forn(i, sums.size())
    {
        now += sums[i];
        sums[i] = now;
    }
    unsigned int ans = 0;
    forn(i, q)
    {
        int l = nextRand();
        int r = nextRand();
        if(l > r)
            swap(l, r);
        ans += get(l, r);
    }
    cout << ans << endl;
    return 0;
}
