#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <stack>

using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 100 * 1000 + 5;
int a[MAXN], l[MAXN], r[MAXN];

int main() {
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    stack<int> st;
    for(int i = 0; i < n; i++) {
        while(!st.empty() && a[st.top()] > a[i])
            st.pop();
        l[i] = st.empty()? 0 : st.top() + 1;
        st.push(i);
    }
    while(!st.empty())
        st.pop();
    for(int i = n - 1; i >= 0; i--) {
        while(!st.empty() && a[st.top()] >= a[i])
            st.pop();
        r[i] = st.empty()? n - 1 : st.top() - 1;
        st.push(i);
    }
    long long ans = 0;
    for(int i = 0; i < n; i++)
        ans += (long long)a[i] * (i - l[i] + 1) * (r[i] - i + 1);
    cout << ans << '\n';
    return 0;
}
