#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef unsigned int uint;

const int N = 100500;
int n;
int a[N];
ll ans;

vector <ii> s;

ll fw[N];

ll get(int ind)
{
	ll res = 0;
	for (int i = ind; i >= 0; i = (i & (i + 1)) - 1)
		res += fw[i];
	return res;
}

ll get(int l, int r)
{
	if (l == 0)
		return get(r);
	return get(r) - get(l - 1);
}

void add(int ind, ll val)
{
	for (int i = ind; i < N; i |= (i + 1))
		fw[i] += val;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ans = 0;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		s.push_back(mp(a[i], i));
	}
	
	sort(s.begin(), s.end());

	for (int i = 0; i < s.size(); i++)
	{
		/* left bp */
		int l = 0, r = s[i].second;
		while (r - l > 1)
		{
			int mid = (l + r) / 2;
			if ( get(mid, s[i].second) )
			{
				l = mid;
			}
			else
			{
				r = mid;
			}
		}
		if ( get(l, s[i].second) ) l++;

		ll L = l, R = 0;

		/* right bp */
		l = s[i].second, r = n - 1;
		while (r - l > 1)
		{
			int mid = (l + r) / 2;
			if ( get(s[i].second, mid) )
			{
				r = mid;
			}
			else
			{
				l = mid;
			}
		}

		if ( get(s[i].second, r) ) r--;

		R = r;

		ans += (s[i].second - L + 1) * (R - s[i].second + 1) * s[i].first;

		add(s[i].second, 1);
	}

	cout << ans;

	return 0;
}