#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <queue>
#include <stack>
using namespace std;

unsigned int a,b;
unsigned int cur = 0;

const long long MOD = 4294967296;

unsigned int nextRand() {
	cur = cur * a + b;
	return cur>>8;
}


vector<long long>vec(16777216 + 100);

int main(){
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int m,q;
	cin>>m>>q;
	cin>>a>>b;
	for(int i=0; i<m; ++i){
		unsigned int add = nextRand();
		unsigned int l = nextRand(), r = nextRand();
		if(l>r)swap(l,r);
		vec[l]+=add;
		vec[r+1]-=add;
	}
	for(int i=1; i<16777216 + 100; ++i){
		vec[i]+=vec[i-1];
	}
	for(int i=1; i<16777216 + 100; ++i){
		vec[i]+=vec[i-1];
	}
	long long res=0;
	for(int i=0; i<q; ++i){
		unsigned int l = nextRand();
		unsigned int r =  nextRand();
		if(l>r)swap(l,r);
		long long crr = vec[r];
		if(l>0)crr-=vec[l-1];
		res+=crr;
		if(res>MOD){
			res-=MOD;
		}
	}
	cout << res%MOD;

	return 0;
}
