#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

typedef long long ll;

const int n = 16777216;

const ll modul = 4294967296;

unsigned cur = 0;
unsigned int a, b;

unsigned int nextRand () {
	cur = cur * a + b;
	return cur >> 8;
}

vector <unsigned int> addq[3];
vector <pair <int, pair<bool, int> > > seq;
vector <ll> ans;

int main () {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int m, q;
	cin >> m >> q;
	cin >> a >> b;
	for (int i = 0; i < m; ++i) {
		unsigned int add = nextRand();
		unsigned int l = nextRand()-1;
		unsigned int r = nextRand()-1;
		if (l > r) swap(l, r);
		addq[0].push_back(l);
		addq[1].push_back(r);
		addq[2].push_back(add);
		seq.push_back(make_pair(l, make_pair(false, i)));
		seq.push_back(make_pair(r, make_pair(true, i)));
	}
	sort(seq.begin(), seq.end());
	ll sum = 0;
	int c = 0;
	for (int i = 0; i < n; ++i) {
		if ((c < 2*m) && (seq[c].first != i)){
			ans.push_back(sum);
		}
		else {
			while ((c < 2*m) && (seq[c].first == i) && (!seq[c].second.first)) {
				sum = (sum + addq[2][ seq[c].second.second ]) % modul;
				++c;	
			}
			ans.push_back(sum);
			while ((c < 2*m) && (seq[c].first == i) && (seq[c].second.first)) {
				sum = (((sum - addq[2][ seq[c].second.second ]) % modul) + modul) % modul;
				++c;	
			}
		}
	}
	sum = 0;
	for (int  i = 0; i <= n; ++i) {
		ll x;
		if (i < n) x = ans[i];
		if (i < n) ans[i] = sum;
		else
			ans.push_back(sum);
		if (i < n) sum = (sum + x) % modul;
	}
	sum = 0;
	for (int i = 0; i < q; ++i) {
		unsigned int l = nextRand()-1;
		unsigned int r = nextRand()-1;
		if (l > r) swap(l, r);
		ll local = ans[ r+1 ] - ans[ l ];
		sum = (sum + local) % modul;
	}

	cout << sum;
	return 0;
}