#if 1
#include <cstdio>
#include <iostream>
using namespace std;
typedef unsigned int uint;
typedef long long li;
uint a, b, cur = 0, sum = 0;
uint nicerand()
{
	cur = cur * a + b;
	return cur >> 8;
}
const uint maxn = 1 << 24;
const uint nsqrt = 1 << 12;
uint arr[maxn], cadd[nsqrt], csum[nsqrt];
uint getsum(uint l, uint r)
{
	uint cl = l / nsqrt;
	uint cr = r / nsqrt;
	uint cursum = 0;
	if(cl != cr)
	{
		for (uint i = l; i < (cl+1) * nsqrt; ++i) cursum += arr[i] + cadd[cl];
		for (uint i = cl + 1; i < cr; ++i) cursum += csum[i];
		for (uint i = cr * nsqrt; i <= r; ++i) cursum += arr[i] + cadd[cr];
	}
	else
	{
		for (uint i = l; i <= r; ++i) cursum += arr[i] + cadd[cl];
	}
	return  cursum;
}
void addval(uint l, uint r, uint val)
{
	uint cl = l / nsqrt;
	uint cr = r / nsqrt;
	if(cl != cr)
	{
		for (uint i = l; i < (cl+1)*nsqrt; ++i) arr[i] += val;
		for (uint i = l; i < (cl+1)*nsqrt; ++i) csum[cl] += val;
		
		for (uint i = cl + 1; i < cr; ++i) cadd[i] += val;
		for (uint i = cl + 1; i < cr; ++i) csum[i] += val * nsqrt;
		
		for (uint i = cr*nsqrt; i <= r; ++i) arr[i] += val;
		for (uint i = cr*nsqrt; i <= r; ++i) csum[cr] += val;
	}
	else
	{
		for (uint i = l; i <= r; ++i) arr[i] += val;
		for (uint i = l; i <= r; ++i) csum[i] += val;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen("fastadd.in", "r", stdin);
	freopen("fastadd.out", "w", stdiout);
#endif
	uint m, q;
	cin >> m >> q >> a >> b;
	for (uint i = 0; i < m; ++i) //[add type]
	{
		uint add = nicerand();
		uint l = nicerand();
		uint r = nicerand();
		if(l > r) swap(l, r);
		addval(l, r, add);
	}
	for (uint i = 0; i < q; ++i) //[sum type]
	{
		uint l = nicerand();
		uint r = nicerand();
		if(l > r) swap(l, r);
		sum += getsum(l, r);
	}
	cout << sum << endl;
	return 0;
}
#endif