/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com5
 * Date: 2014.09.12
 */

#include <cstdio>
#include <cassert>
#include <algorithm>
#include <iostream>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef unsigned int uint;

uint cur = 0, a, b;
inline uint gen() {
  cur = cur * a + b;
  return cur >> 8;
}

int l, r;
inline void gen_seg() {
  l = gen();
  r = gen();
  if (l > r)
    swap(l, r);
}

const int N = 1 << 24;

int m, q;
uint x[N];

int main() {
  #define NAME "fastadd"
  assert(freopen(NAME ".in", "r", stdin));
  assert(freopen(NAME ".out", "w", stdout));

  cin >> m >> q >> a >> b;
  while (m--) {
    uint add = gen();
    for (gen_seg(); l <= r; l++)
      x[l] += add;
  }

  uint res = 0;
  while (q--)
    for (gen_seg(); l <= r; l++)
      res += x[l];
  cout << res << endl;
  return 0;
}
