/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 * Date: 2014.08.03
 * OK, 0.028 sec, 1.6 mb
 */

#include <cstdio>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define fornd(i, n) for (int i = (int)(n) - 1; i >= 0; i--)

typedef long long ll;

const int N = 1e5;

ll sum;
int n, a[N], l[N], r[N];
vector <int> s;

int main() {
  #define NAME "minsum"
  assert(freopen(NAME ".in", "r", stdin));
  assert(freopen(NAME ".out", "w", stdout));

  assert(scanf("%d", &n) == 1 && n <= N);
  forn(i, n)
    scanf("%d", &a[i]);
  s.reserve(n);

  forn(i, n) {
    while (s.size() && a[*s.rbegin()] > a[i])
      r[*s.rbegin()] = i, s.pop_back();
    s.push_back(i);
  }
  while (s.size())
    r[*s.rbegin()] = n, s.pop_back();
  
  fornd(i, n) {
    while (s.size() && a[*s.rbegin()] >= a[i])
      l[*s.rbegin()] = i, s.pop_back();
    s.push_back(i);
  }
  while (s.size())
    l[*s.rbegin()] = -1, s.pop_back();

  forn(i, n)
    sum += (ll)(i - l[i]) * (r[i] - i) * a[i];
  cout << sum << endl;
  return 0;
}
