import java.util.Set;
import java.util.HashSet;
import java.util.Random;

public class do12 {
    static class Point {
        public int x;
        public int y;

        public Point(int x, int y) {
            this.x = x;
            this.y = y;
        }

        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Point point = (Point) o;

            if (x != point.x) return false;
            if (y != point.y) return false;

            return true;
        }

        public int hashCode() {
            int result;
            result = x;
            result = 3137 * result + y;
            return result;
        }
    }

    static Set<Point> all = new HashSet<Point>();
    static Random random = new Random(59410651354121L * do12.class.getName().hashCode());

    static boolean verify(int x, int y) {
        return true;
    }

    public static void main(String[] args) {
        int n = 30000;
        int w = 1000000000;
        int h = 1000000000;

        while (all.size() < n) {
            int x = random.nextInt(w + 1);
            int y = random.nextInt(h + 1);
            Point p = new Point(x, y);
            if (verify(p.x, p.y) && !all.contains(p)) {
                all.add(p);
            }
        }

        Point[] pp = all.toArray(new Point[0]);
        for (int i = 0; i < pp.length; ++i) {
            int j = i + random.nextInt(pp.length - i);
            if (i != j) {
                Point t = pp[i];
                pp[i] = pp[j];
                pp[j] = t;
            }
        }

        System.out.println(w + " " + h);
        System.out.println(n);
        for (Point z : pp)
            System.out.println(z.x + " " + z.y);
    }
}
