#include <cstdio>
#include <cstdlib>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

#define MP make_pair
#define R(a) ((rand() + (rand() << 15)) % (a))

__int64 Time( void )
{
  _asm rdtsc;
}

int main( int argc, char *argv[] )
{
  int w = atoi(argv[1]), h = atoi(argv[2]), n = atoi(argv[3]);
  set < pair<int, int> > s;
  vector < pair<int, int> > v;

  printf("%d %d\n%d\n", w, h, n);
  srand(Time());
  while (n--)
  {
    int x, y;
    do
      x = R(w + 1), y = R(h + 1);
    while (s.count(MP(x, y)));
    s.insert(MP(x, y));
  }
  for (set < pair<int, int> >::iterator it = s.begin(); it != s.end(); it++)
    v.push_back(*it);
  random_shuffle(v.begin(), v.end());
  for (int i = 0; i < v.size(); i++)
    printf("%d %d\n", v[i].first, v[i].second);
  return 0;
}
