#include <cstdio>
#include <algorithm>

using namespace std;

#include "random.h"

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

int main( int argc, char *argv[] )
{
  if (argc < 3)
  {
    puts("Usage: <seed for random> <n>");
    puts("  [seed == 0] => Time()");
    return 1;
  }

  int seed = atoi(argv[1]);
  int n = atoi(argv[2]);
  initrand(seed ? seed : Time());

  forn(i, n)
    if (i < n / 2)
      printf("wall %d %d %d %d\n", -10000 + R(0, 100), R(1, 100), 10000 - R(0, 100), R(1, 100));
    else if (i + 1 < n)
      printf("shot %d %d\n", R(-100, 100), R(1, 100));
    else
      puts("end");
  return 0;
}
