
#ifdef BURUNDUK
#  include "my_testlib.h"
#else
#  include "testlib.h"
#endif

#include <string>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

const int N = (int)5e4;
const int C = (int)1e4;

int main(int, char *[])
{
  registerValidation();

  string s;
  int n = 1; // end
  while ((s = inf.readWord()) != "end")
  {
    ensure(++n <= N);
    ensure(s == "shot" || s == "wall");
    inf.readSpace();
    if (s == "shot")
    {
      int x = inf.readInt(-C, C);
      inf.readSpace();
      int y = inf.readInt(-C, C);
      ensure(x || y);
    }
    else
    {
      int x1 = inf.readInt(-C, C);
      inf.readSpace();
      int y1 = inf.readInt(-C, C);
      inf.readSpace();
      int x2 = inf.readInt(-C, C);
      inf.readSpace();
      int y2 = inf.readInt(-C, C);
    }
    inf.readEoln();
  }
  inf.readEoln();
  inf.readEof();
  return 0;
}
