#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e5+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, a[maxn], two[maxn], dp[17][maxn];

void process() {
	two[1] = 0;
	for(int i = 2; i < maxn; i++) two[i] = two[i>>1] + 1;
	for(int i = 0; i < n; i++) dp[0][i] = a[i];
	for(int lvl = 1; (1<<lvl) <= n; lvl++) {
		for(int i = 0; i + (1<<lvl) <= n; i++) {
			dp[lvl][i] = min(dp[lvl-1][i], dp[lvl-1][i+(1<<(lvl-1))]);
		}
	}
}

int get(int l, int r) {
	if(l > r) return inf;
	int lvl = two[r-l+1];
	int ans1 = dp[lvl][l];
	int ans2 = dp[lvl][r-(1<<lvl)+1];
	return min(ans1, ans2);
}


int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	scanf("%d", &n);
	for(int i = 0; i < n; i++) scanf("%d", &a[i]);

	process();

	ll ans = 0;

	for(int i = 0; i < n; i++) {
		int L = -1, R = i;
		int l = 0, r = i-1;
		while(l <= r) {
			int mid = (l + r) >> 1;
			if(get(mid, i-1) > a[i]) {
				L = mid;
				r = mid - 1;
			} else l = mid + 1;
		}
		l = i+1; r = n-1;
		while(l <= r) {
			int mid = (l + r) >> 1;
			if(get(i, mid) == a[i]) {
				R = mid;
				l = mid + 1;
			} else r = mid - 1;
		}
		//cout << i << ": " << L << " " << R << endl;
		if(L == -1) L = 1;
		else L = i-L+1;
		R = R-i+1;
		ans += R * 1ll * L * 1ll * a[i];
		//cout << i << " " << L << " " << R << " " << a[i] << endl;
	}

	cout << ans << endl;


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
