#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<24;
const int inf = 1<<30;

unsigned int m, q, a, b, n;
unsigned int cur;
unsigned int t[N+2], s[N+2];

unsigned int nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	n = 1<<24;
	cin >> m >> q >> a >> b;
	for (int i = 0; i < m; i++) {
		unsigned int add = nextRand();
		unsigned int l = nextRand();
		unsigned int r = nextRand();
		if (l > r) swap(l, r); r++;
		t[l] += add;
		t[r] -= add;
	}
	for (unsigned int i = 0, val = 0, sum = 0; i <= n; i++) {
		val += t[i];
		sum += val;
		s[i] = sum;
	}
	unsigned int sum = 0;
	for (unsigned int i = 0; i < q; i++) {
		unsigned int l = nextRand();
		unsigned int r = nextRand();
		if (l > r) swap(l, r);
		sum += s[r];
		if (l > 0) sum -= s[l-1];
	}
	cout << sum;

	return 0;
}
