#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

char str[11];

vector<int> v[5555],s[5555];
int nxt[5555];

int head = 0;

void print() {
	for (int i = head; i != -1; i = nxt[i]) {
		for (int j = 0; j < sz(v[i]); j++) {
			cout << v[i][j] << " ";
		}
	}
	cout << endl;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int n; cin >> n;

	int ID = (n - 1) / 450 + 1;

	for (int i = 0; i < n; i++) {
		int x; scanf("%d",&x);
		int id = i / 450;
		v[id].pb(x);
		s[id].pb(x);
	}
	
	for (int i = 0; i < (n - 1) / 450; i++) {
		nxt[i] = i + 1;
	}
	nxt[(n - 1) / 450] = -1;

	for (int i = 0; i <= (n - 1) / 450; i++) {
		sort(all(s[i]));
	}

	int iter = 0;

	int N = n;
	
	while(scanf("%s",&str) == 1) {
		iter++;
		//cout << "--" << iter << endl;
		char ch = str[0];
		if (ch == '-') {
			N--;
			int p; scanf("%d",&p);
			int pos = 0;
			for (int i = head; i != -1; i = nxt[i]) {
				if (pos + sz(v[i]) > p) {
					p -= pos;
					int pp = -1;
					for (int j = 0; j < sz(s[i]); j++) {
						if (s[i][j] == v[i][p]) {
							pp = j;
							break;
						}
					}
					while(pp == -1) {}
					s[i].erase(s[i].begin() + pp);
					v[i].erase(v[i].begin() + p);
					break;
				} else {
					pos += sz(v[i]);
				}
			}
		} else if (ch == '+') {
			N++;
			int p,val; scanf("%d%d",&p,&val);
			int pos = 0;
			for (int i = head; i != -1; i = nxt[i]) {
				if (N == 1) {
					assert(i == 0);
					v[i].pb(val);
					s[i].pb(val);
					nxt[i] = -1;
					ID++;
					continue;
				} 
				if (v[i].empty()) continue;
				if (pos + sz(v[i]) > p || nxt[i] == -1) {
					p -= pos;
					v[i].insert(v[i].begin() + p,val);
					//if (iter == 5) cout << sz(s[i]) << endl;
					s[i].pb(val);
					int ptr = sz(s[i]) - 1;
					while(ptr > 0 && s[i][ptr - 1] > s[i][ptr]) {
						swap(s[i][ptr - 1],s[i][ptr]);
						ptr--;
					}
					if (sz(v[i]) >= 900) {
						v[ID].resize(450);
						for (int j = 0; j < 450; j++) {
							v[ID][j] = v[i][sz(v[i]) - 450 + j];
						}
						for (int j = 0; j < 450; j++) {
							v[i].pop_back();
						}
						s[i] = v[i];
						sort(all(s[i]));
						s[ID] = v[ID];
						sort(all(s[ID]));
						int next = nxt[i];
						nxt[i] = ID;
						nxt[ID] = next;
						ID++;
                    }
					break;
			    } else {
			    	p += sz(v[i]);
			    }
			}
		} else {
			int ans = 0;
			int l,r,val; scanf("%d%d%d",&l,&r,&val);
			int pos = 0;
			for (int i = head; i != -1; i = nxt[i]) {
				int L = pos;
				int R = pos + sz(v[i]) - 1;
				pos += sz(v[i]);
				if (r < L || R < l) continue;				
				if (l <= L && R <= r) {
					ans += upper_bound(all(s[i]),val) - s[i].begin();
					continue;
				}
				for (int j = 0; j < sz(v[i]); j++) {
					int cur = L + j;
					if (l <= cur && cur <= r && v[i][j] <= val) ans++;
				}
			}
			printf("%d\n",ans);
		}
		//print();
	}

	return 0;
}
