#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

unsigned int t[1 << 24];
//unsigned int s[1 << 24];

unsigned int a, b;
unsigned int cur = 0;
unsigned int nextRand() {
    cur = cur * a + b;
    return cur >> 8;
}

class seg{
public:
    unsigned int l, r, x;
    seg() {};
};

class event{
public:
    unsigned int x, value;
    int type;
    event() {}
};

inline bool cmp(const event & a, const event & b) {
    return a.x < b.x;
}

vector<event> z, z2;

void build() {
    //s[0] = t[0];
    for (int i = 0; i < (1 << 24); ++i)
        t[i] = t[i - 1] + t[i];
}

unsigned int getSum(unsigned int l, unsigned int r) {
    if (l == 0) return t[r];
    return t[r] - t[l - 1];
}

unsigned int counter[1 << 24];

int cnt = 0;


void count_sort() {
    for (int i = 0; i < z.size(); ++i) {
//        cerr << z[i].x << endl;
//        counter[z[i].x].push_back(z[i]);
        if (z[i].type == 0)
            counter[z[i].x] += z[i].value;
        else counter[z[i].x] -= z[i].value;
    }

//    cerr << "Here" << endl;


    for (int i = 0; i < (1 << 24); ++i) {
//        if (counter[i].size() != 0) cerr << counter[i].size() << endl;
            event tmp;
            tmp.value = counter[i];
            tmp.x = i;
            tmp.type = 0;
            z2.push_back(tmp);
    }

    z = z2;
}

int main()
{
    unsigned int m, q;
    cin >> m >> q;
    cin >> a >> b;

    z.reserve(1 << 24);

    int cnt1 = 0, cnt2 = 0;
    long long sum_len = 0;

    for (int i = 0; i < m; ++i) {
        unsigned int add = nextRand();
        unsigned int l = nextRand();
        unsigned int r = nextRand();
        if (l > r) swap(l, r);
/*        seg tmp;
        tmp.l = l;
        tmp.r = r;
        tmp.x = add;*/
        event tmp;
        tmp.x = l;
        tmp.type = 0;
        tmp.value = add;
        z.push_back(tmp);
        tmp.x = r + 1;
        tmp.type = 1;
        tmp.value = add;
        z.push_back(tmp);
/*        if (r - l <= (7100)) ++cnt1;
        else ++cnt2;
        sum_len += r - l;*/
    }

/*    long long lens = sqrt(sum_len);

    for (int i = 0; i < m; ++i) {
        unsigned int l = z[i].l;
        unsigned int r = z[i].r;
        unsigned int
        if ()
        event tmp;
        tmp.x = l;
        tmp.type = 0;
        tmp.value = add;
        z.push_back(tmp);
        tmp.x = r + 1;
        tmp.type = 1;
        tmp.value = add;
        z.push_back(tmp);
        if (r - l <= (1e7)) ++cnt1;
        else ++cnt2;
    }*/

/*    cout << cnt1 << " " << cnt2 << endl;
    cout << sum_len << endl;

    cerr << "Here" << endl;*/

    count_sort();
//    sort(z.begin(), z.end(), cmp);

//    cerr << "Here" << endl;

    int p = 0;
    unsigned int added = 0;
    for (int i = 0; i < (1 << 24); ++i) {
        while (p < z.size() && z[p].x == i) {
            if (z[p].type == 0) added += z[p].value;
            else added -= z[p].value;
            ++p;
        }
        t[i] += added;
    }

    build();

    unsigned int ans = 0;

    for (int i = 0; i < q; ++i) {
        unsigned int l = nextRand();
        unsigned int r = nextRand();
        if (l > r) swap(l, r);
        ans += getSum(l, r);
//        cout << getSum(l, r) << endl;
    }

    cout << ans << endl;

    return 0;
}
