#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

unsigned int t[(1 << 24) + 5];

unsigned int a, b;
unsigned int cur = 0;
unsigned int nextRand() {
    cur = cur * a + b;
    return cur >> 8;
}

void build() {
    for (int i = 1; i <= (1 << 24); ++i)
        t[i] = t[i - 1] + t[i];
}

unsigned int getSum(unsigned int l, unsigned int r) {
    if (l == 0) return t[r];
    return t[r] - t[l - 1];
}

unsigned int counter[(1 << 24) + 5];

int cnt = 0;

int main()
{
    unsigned int m, q;
    cin >> m >> q;
    cin >> a >> b;

    for (int i = 0; i < m; ++i) {
        unsigned int add = nextRand();
        unsigned int l = nextRand();
        unsigned int r = nextRand();
        if (l > r) swap(l, r);
        counter[l] += add;
        counter[r + 1] -= add;
    }

    unsigned int added = 0;
    for (int i = 0; i <= (1 << 24) + 5; ++i) {
        added += counter[i];
        t[i] += added;
    }

    build();

    unsigned int ans = 0;

    for (int i = 0; i < q; ++i) {
        unsigned int l = nextRand();
        unsigned int r = nextRand();
        if (l > r) swap(l, r);
        ans += getSum(l, r);
    }

    cout << ans << endl;

    return 0;
}
