#include <iostream>
#include <stack>
#include <algorithm>
#include <vector>

using namespace std;

stack<pair<int, int> > s;

vector<int> a, l, r;

int main()
{
    int n;
    cin >> n;
    a.resize(n);
    l.resize(n, -1);
    r.resize(n, n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    s.push(make_pair(a[0], 0));

    for (int i = 1; i < n; ++i) {
        pair<int, int> tmp = s.top();
        while (s.size() && tmp.first > a[i]) {
            s.pop();
            if (s.size() != 0)
                tmp = s.top();
            else tmp = make_pair(-1, -1);
        }

        l[i] = tmp.second;

        s.push(make_pair(a[i], i));
    }

    while (s.size())
        s.pop();

    s.push(make_pair(a[n - 1], n - 1));
    for (int i = n - 2; i >= 0; --i) {
        pair<int, int> tmp = s.top();
        while (s.size() && tmp.first > a[i]) {
            s.pop();
            if (s.size() != 0)
                tmp = s.top();
            else tmp = make_pair(n, n);
        }

        r[i] = tmp.second;

        s.push(make_pair(a[i], i));
    }

    long long ans = 0;

    for (int i = 0; i < n; ++i) {
//        cerr << a[i] << " " << l[i] << " " << r[i] << endl;
        int c1 = i - l[i];
        int c2 = r[i] - i;
        ans += (c1) * (c2) * a[i];
    }

    cout << ans << endl;


    return 0;
}
