#include <iostream>
#include <stack>
#include <algorithm>
#include <vector>
#include <ctime>
#include <cassert>
#include <map>

using namespace std;

stack<pair<int, int> > s;

vector<int> a, l, r;
map<int, int> z;

long long stupid_solve(vector<int> & a) {
    long long ans = 0;
    for (int l = 0; l < a.size(); ++l)
        for (int r = l; r < a.size(); ++r) {
            int mn = 1e9;
            for (int i = l; i <= r; ++i)
                mn = min(mn, a[i]);
            ans += mn;
            z[mn] += 1;
        }
    return ans;
}

int main()
{
    srand(time(0));
while (true) {
    int n = 10;
    cin >> n;
    a.resize(n);
    l.resize(n, -1);
    r.resize(n, n);
    for (int i = 0; i < n; ++i)
//        a[i] = int(rand() * rand()) % int(2 * 1e6) - 1e6;
        cin >> a[i];

    while (s.size())
        s.pop();

    s.push(make_pair(a[0], 0));

    for (int i = 1; i < n; ++i) {
        pair<int, int> tmp = s.top();
        while (s.size() && tmp.first >= a[i]) {
            s.pop();
            if (s.size() != 0)
                tmp = s.top();
            else tmp = make_pair(-1, -1);
        }

        l[i] = tmp.second;

        s.push(make_pair(a[i], i));
    }

    while (s.size())
        s.pop();

    s.push(make_pair(a[n - 1], n - 1));
    for (int i = n - 2; i >= 0; --i) {
        pair<int, int> tmp = s.top();
        while (s.size() && tmp.first > a[i]) {
            s.pop();
            if (s.size() != 0)
                tmp = s.top();
            else tmp = make_pair(n, n);
        }

        r[i] = tmp.second;

        s.push(make_pair(a[i], i));
    }

    long long ans = 0;
//    long long ans2 = stupid_solve(a);


    for (int i = 0; i < n; ++i) {
        //cerr << a[i] << " " << l[i] << " " << r[i] << endl;
        long long c1 = i - l[i];
        long long c2 = r[i] - i;
        //cerr << c1 * c2 << " " << z[a[i]] << endl;
        ans += (c1) * (c2) * a[i];
    }


    cout << ans << endl;
/*    cout << ans << " " << ans2 << endl;
    if (ans != ans2) {
        cout << n << endl;
        for (int i = 0; i < n; ++i)
            cout << a[i] << endl;
        cout << endl;
        return 1;
    }*/
    return 0;
}
    return 0;
}
