#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

unsigned int a, b;
unsigned int cur = 0;
unsigned int nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

const int MAXN = (1 << 24);

int n, m;
unsigned int add[MAXN + 1];

int main() {
	//freopen("fastadd.in", "r", stdin);
	//freopen("fastadd.out", "w", stdout);
	scanf("%d%d", &n, &m);
	scanf("%u%u", &a, &b);
	for(int i = 0; i  < m; i++) {
		unsigned int k = nextRand();
		unsigned int l = nextRand();
		unsigned int r = nextRand();
		if(l > r) swap(l, r);
		add[l] += k;
		add[r + 1] -= k;
	}
	for(int i = 1; i < MAXN; i++)
		add[i] += add[i - 1];
	for(int i = 1; i < MAXN; i++)
		add[i] += add[i - 1];
	unsigned int sum = 0;
	for(int i = 0; i < m; i++) {
		unsigned int l = nextRand();
		unsigned int r = nextRand();
		if(l > r) swap(l, r);
		unsigned int result = add[r] - (l == 0 ? 0 : add[l - 1]);
		sum += result;
	}
	printf("%u\n", sum);
	return 0;
}