#include <iostream>
#include <vector>

using namespace std;

const long long n = 16777216;
const long long k = 4096;
const unsigned long long MOD = 4294967296;

unsigned long long a, b;
unsigned int cur = 0;

unsigned int nextRand()
{
	cur = cur *a +b;
	return cur >> 8;
}

void getQuery(unsigned int &l, unsigned int &r)
{
	l = nextRand();
	r = nextRand();
	if(l > r) swap(l, r);
}

void setQuery(unsigned int &add, unsigned int &l, unsigned int &r)
{
	add = nextRand();
	l = nextRand();
	r = nextRand();
	if(l > r) swap(l, r);
}

unsigned long long s[n];
unsigned long long ar[n];
unsigned long long addition[n+1];

int main()
{
	int m, q;
	cin >> m >> q;
	cin >> a >> b;	

	unsigned int add, l, r;
	unsigned long long ans = 0;
	for(int i = 0; i < m; i++)
	{
		setQuery(add, l, r);
		addition[l] += add;
		addition[r+1] -= add;
	}
	unsigned long long sum = 0;
	for(int i = 0; i < n; i++)
	{
		sum = (sum + addition[i]) % MOD;
		ar[i] = sum;
		s[i/k] = (sum + s[i/k]) % MOD;
	}
	for(int i = 0; i < q; i++)
	{
		getQuery(l, r);
		int l1 = l / k;
		if(l % k) l1 += 1;
		int r1 = r / k - 1;
		for(int j = l; j < l1 * k; j++)
		{
			ans = (ans + ar[j]) % MOD;
		}
		for(int j = k*(r1+1); j <= r; j++)
		{
			ans = (ans + ar[j]) % MOD;
		}
		for(int j = l1; j <= r1; j++)
		{
			ans = (ans + s[j]) % MOD;
		}
	}
	cout << ans;
	//cin >> ans;
	return 0;
}