#include <iostream>
using namespace std;


typedef unsigned int uint;


const int N = (1 << 24);

uint arr[N];

uint a, b;
uint cur = 0;

uint NextRand()
{
    cur = cur * a + b;
    return cur >> 8;
}

uint l, r;
uint add;

void NextSecondQuery()
{
    l = NextRand();
    r = NextRand();
    if (l > r) {
        swap(l, r);
    }
}

void NextFirstQuery()
{
    add = NextRand();

    NextSecondQuery();
}

uint GetQuery()
{
    if (l == 0) {
        return arr[r];
    } else {
        return arr[r] - arr[l - 1];
    }
}

int main()
{
    ios_base::sync_with_stdio(false);

    int m, q;
    cin >> m >> q;
    cin >> a >> b;

    for (int i = 0; i < m; ++i) {
        NextFirstQuery();

        arr[l] += add;
        if (r + 1 < N) {
            arr[r + 1] -= add;
        }
    }

    uint counter = 0;
    for (int i = 0; i < N; ++i) {
        counter += arr[i];
        arr[i] = counter;
    }

    for (int i = 1; i < N; ++i) {
        arr[i] += arr[i - 1];
    }

    uint sum = 0;
    for (int i = 0; i < q; ++i) {
        NextSecondQuery();

        sum += GetQuery();
    }


    cout << sum << endl;

    return 0;
}
