#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

typedef unsigned int uint;
uint a, b;
uint cur = 0;
uint nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

int ar[(1<<24) + 10];


void solve() {
	int m, q;
	cin >> m >> q;
	cin >> a >> b;
	uint ans = 0;
	while(m--) {
		int add = nextRand();
		int l = nextRand();
		int r = nextRand();
		if(l > r)
			swap(l, r);
		//cout << l << ' ' << r << endl;
		++r;
		ar[l + 1] += add;
		ar[r + 1] -= add;
	}

	for(int i = 0; i <= (1<<24); ++i) {
		ar[i + 1] += ar[i];
	}
	for(int i = 0; i <= (1<<24); ++i) {
		ar[i + 1] += ar[i];
	}

	while(q--) {
		int l = nextRand();
		int r = nextRand();
		if(l > r)
			swap(l, r);
		++r;
		ans += ar[r] - ar[l];
	}

	cout << ans;
}