#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>

using namespace std;

typedef long long li;

const int MAXN = ((1 << 24) + 100);
int n = (1 << 24);

unsigned int add[MAXN];
unsigned int arr[MAXN];
unsigned int sum[MAXN];
int m, q;

unsigned int a, b;
unsigned int cur = 0;
inline unsigned int nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

int main() {
	freopen("fastadd.in", "r", stdin);
	freopen("fastadd.out", "w", stdout);
	cin >> m >> q;
	cin >> a >> b;

	for (int i = 0; i < m; i++) {
		li add1 = nextRand();
		int l = nextRand();
		int r = nextRand();
		if (l > r)
			swap(l, r);
		add[l] += add1;
		add[r + 1] -= add1;
	}

	int curAdd = 0;
	for (int i = 0; i < n; i++) {
		curAdd += add[i];
		arr[i] = curAdd;
	}

	for (int i = 0; i < n; i++)
		sum[i + 1] = sum[i] + arr[i];

	unsigned int res = 0;
	for (int i = 0; i < q; i++) {
		int l = nextRand();
		int r = nextRand();
		if (l > r)
			swap(l, r);
		res += sum[r + 1] - sum[l];
	}
	cout << res << endl;
}