#include <bits/stdc++.h>

using namespace std;

unsigned int a, b;
unsigned int cur = 0;
unsigned int nextRand()
{
    cur = cur * a + b;
    return cur >> 8;
}

const int MAXN = 1 << 24;
unsigned int sum[MAXN << 1], mod[MAXN << 1];

void add(int a, int b, int c, int v = 1, int l = 0, int r = MAXN)
{
    if(a <= l && r <= b)
    {
        mod[v] += c;
        sum[v] += (r - l) * c;
        return;
    }
    if(r <= a || b <= l)
        return;
    int m = (l + r) / 2;
    add(a, b, c, v * 2, l, m);
    add(a, b, c, v * 2 + 1, m, r);
    sum[v] += c * (min(b, r) - max(a, l));
}

int get(int a, int b, int v = 1, int l = 0, int r = MAXN)
{
    if(a <= l && r <= b)
        return sum[v];
    if(r <= a || b <= l)
        return 0;
    int m = (l + r) / 2;
    return mod[v] * (min(b, r) - max(a, l)) + get(a, b, v * 2, l, m) + get(a, b, v * 2 + 1, m, r);
}

main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int m, q;
    cin >> m >> q;
    cin >> a >> b;
    while(m--)
    {
        int c = nextRand();
        int l = nextRand();
        int r = nextRand();
        if(l > r) swap(l, r);
        r++;
        add(l, r, c);
    }
    unsigned int sum = 0;
    while(q--)
    {
        int l = nextRand();
        int r = nextRand();
        if(l > r) swap(l, r);
        r++;
        sum += get(l, r);
    }
    cout << sum << "\n";

}
