#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 100100;

struct Input {
	int n;
	int a[N];
		
	bool read () {
		if (scanf ("%d",&n) != 1)
			return 0;
		forn(i, n) {
			scanf ("%d", &a[i + 1]);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans = 0;
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int inf = 1000000000;

struct Solution: Data {

	vector <pair<int, int> > st;
	int l[N], r[N];
	
	void solve () {
		a[0] = -inf;
		a[n + 1] = -inf;
		memset(l, -1, sizeof(l));
		n += 2;
		forn(i, n) {
			r[i] = n;
		}
		forn(i, n) {
			while (!st.empty() && st.back() > mp(a[i], i)) {
				st.pop_back();
			}
			if (!st.empty())
				l[i] = st.back().sc; 
			st.push_back(mp(a[i], i));
		}	 
		st.clear();
		ford(i, n) {
			while (!st.empty() && st.back() > mp(a[i], i)) {
				st.pop_back();
			}
			if (!st.empty())
				r[i] = st.back().sc; 
			st.push_back(mp(a[i], i));
		}
		for (int i = 1; i < n - 1; ++i) {
			int l1 = l[i], r1 = r[i];
			ans += 1ll * a[i] * 1ll * (i - l1) * (r1 - i);
		}
		
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
