#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

struct Input {
	int n;
	int X, Y;
	ve<pii> p;
	
	bool read () {
		if (!(cin >> X >> Y)) {
			return 0;
		}
		scanf("%d", &n);
		forn (i, n) {
			int x, y;
			scanf("%d%d", &x, &y);
			p.pb(mp(x, y));
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	pii pAns;
	
	void write () {
		printf("%d\n", ans);
		printf("%d %d\n", pAns.fs, pAns.sc);
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int N = 2e5 + 10;

struct Solution: Data {
	int next[N], prev[N];
	set<int> t;
	
	/*
	int upp_bound (int x) {
		++x;
		int e = 1, l = 0, r = n + 2;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (x >= m || t[2 * e] == 0) {
				e = 2 * e + 1;
				l = m;
			}
			else {
				e = 2 * e;
				r = m;
			}
		}
		return l;
	}
*/	
	
	int upp_bound (int x) {
		return *t.upper_bound(x);
	}

/*	
	int upp_bound (int x) {
		int cur = 0;
		while (cur <= x) {
			cur = next[cur];
		}
		return cur;
	}
*/	
	
	void ins (int x) {
		t.insert(x);
	}
	void del (int x) {
		t.erase(x);
	}
	
	int num[N];
	int pos[N];
	
	void add (int v) {
		int nx = upp_bound(v);
		int pr = prev[nx];
		ins(v);
		next[pr] = v;
		prev[v] = pr;
		next[v] = nx;
		prev[nx] = v;
	}
	
	int del (int v, int A) {
		int pr = prev[v];
		int nx = next[v];
		del(v);
		next[pr] = nx;
		prev[nx] = pr;
		if (p[num[nx]].sc - p[num[pr]].sc >= A) {
			return p[num[pr]].sc;
		}
		return -1;
	}
	
	pii f (int A) {
		t.clear();
		ins(pos[n]);
		ins(pos[n + 1]);
		next[pos[n]] = pos[n + 1];
		prev[pos[n + 1]] = pos[n];
		int r = 0;
		
		
		for (int l = -1; l < n; ++l) {
			while (r < n && p[r].fs - ((l < 0) ? 0 : p[l].fs) < A) {
				add(pos[r]);
				++r;
			}
			if (l != -1) {
				int y = del(pos[l], A);
				if (y != -1 && X - p[l].fs >= A) {
					return mp(p[l].fs, y);
				}
			} else {
				int cur = pos[n];
				while (cur != pos[n + 1]) {
					int nx = next[cur];
					if (p[num[nx]].sc - p[num[cur]].sc >= A) {
						return mp(0, p[num[cur]].sc);
					}
					cur = nx;
				}
			}
		}
		return mp(-1, -1);
	}
	
	void solve () {
		sort(all(p));
		p.pb(mp(X + 1, 0));
		p.pb(mp(X + 1, Y));
		forn (i, sz(p)) {
			num[i] = i;
		}
		sort(num, num + sz(p), [&] (int i, int j) {
			if ((i == n) ^ (j == n)) {
				return i == n;
			}
			if ((i == n + 1) ^ (j == n + 1)) {
				return j == n + 1;
			}
			return p[i].sc < p[j].sc;
		});
		forn (i, sz(p)) {
			pos[num[i]] = i;
		}
		int left = 0, right = min(X, Y) + 1;
		while (left + 1 < right) {
			int middle = (left + right) / 2;
			if (f(middle) != mp(-1, -1)) {
				left = middle;
			}
			else {
				right = middle;
			}
		}
		ans = left;
		pAns = f(left);
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("e.in", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
