#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())

const int size = (1 << 24);

unsigned int a, b;
unsigned int der[size + 3];
unsigned int val[size + 3];
unsigned int sum[size + 3];
unsigned int cur = 0;

unsigned int nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

int main() {
	int m, q;
	
	assert(freopen("fastadd.in", "r", stdin));
	assert(freopen("fastadd.out", "w", stdout));

	scanf("%d%d", &m, &q);
	scanf("%u%u", &a, &b);
	int l, r;

	for (int i = 0; i < m; i++) {
		unsigned int add = nextRand();
		l = nextRand();
		r = nextRand();
	
		if (l > r) swap(l, r);


		der[l] += add;
		der[r + 1] -= add;
	}

	unsigned int curval = 0;
	for (int i = 0; i <= size; i++) {
		curval += der[i];
		val[i] = curval;
	}

	sum[0] = 0;
	for (int i = 0; i <= size; i++)
		sum[i + 1] = sum[i] + val[i];

	unsigned int ans = 0;
	for (int i = 0; i < q; i++) {
		l = nextRand();
		r = nextRand();
	
		if (l > r) swap(l, r);

		ans += sum[r + 1] - sum[l];
	}

	cout << ans << endl;

	return 0;
}