#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
const double pi = acos(-1.0);
const int MAX_VALUE = (int) 2e6 + 10;
const int SHIFT = (int) 1e6;
const int N = (int) 1e5;
vector<int> who[MAX_VALUE];
int64 res = 0;
int p[N], x, n, size[N], a[N];

int dsu_find(int x) {
	return (x == p[x]) ? x : (p[x] = dsu_find(p[x]));
}

void add(int pos, int value) {
	int v = dsu_find(pos);
	if ((pos > 0) && (a[pos - 1] >= value)) {
		int u = dsu_find(pos - 1);
		res += size[u] * (int64) size[v] * (value - SHIFT);
		p[u] = v, size[v] += size[u];
	}
	if ((pos + 1 < n) && (a[pos + 1] >= value)) {
		int u = dsu_find(pos + 1);
		res += size[u] * (int64) size[v] * (value - SHIFT);
		p[u] = v, size[v] += size[u];
	}
}

int main() {
	assert(freopen("minsum.in", "r", stdin));
	assert(freopen("minsum.out", "w", stdout));
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]), a[i] += SHIFT;
		who[a[i]].pb(i);
		p[i] = i, size[i] = 1, res += a[i] - SHIFT;
	}
	for (int x = MAX_VALUE - 1; x >= 0; --x)
		for (int i = 0; i < sz(who[x]); ++i)
			add(who[x][i], x);
	printf("%lld\n", res);
	return 0;
}