#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;
typedef unsigned int uint;

uint a, b;
uint cur = 0;

uint nextRand()
{
	cur = cur * a + b;
	return cur >> 8;
}

uint psums[(1 << 24) + 1];

int
main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("fastadd.in", "r", stdin); freopen("fastadd.out", "w", stdout);
	
	int m, q;
	scanf("%d%d%u%u", &m, &q, &a, &b);
	for (int i = 0; i <= (1 << 24); ++i) {
		psums[i] = 0;
	}
	for (int i = 1; i <= m; ++i) {
		uint add = nextRand();
		uint l = nextRand();
		uint r = nextRand();
		if (l > r) swap(l, r);
		psums[l] += add;
		psums[r + 1] -= add;
	}
	uint curVal = 0;
	for (int i = 0; i < (1 << 24); ++i) {
		curVal += psums[i];
		psums[i] = curVal;
	}
	curVal = 0;
	for (int i = 0; i < (1 << 24); ++i) {
		curVal += psums[i];
		psums[i] = curVal;
	}
	uint sum = 0;
	for (int i = 0; i < q; ++i) {
		uint l = nextRand(), r = nextRand();
		if (l > r) swap(l, r);
		sum += psums[r];
		if (l) {
			sum -= psums[l - 1];
		}
	}
	printf("%u\n", sum);
	return 0;
}