#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;

/*int a[maxn];
int n;

class Segment {
public:
	int l, r;
	vector <int> v;
	Segment (int _l, int _r) {
		l = _l;
		r = _r;
		v.assign(a + l, a + r);
		sort(all(v));
	}
	int get (int x) {
		return upper_bound(all(v), x) - v.begin();
	}
};

vector <Segment*> T;

int split (int i) {
	int l = -1, r = sz(T);
	while (l < r) {
		int m = (l + r)/2;
		if (T[m]->l <= i)
			l = m;
		else
			r = m;
	}
	if (T[l]->l == i)
		return i;
	else {
		Segment * b = new Segment(l, i);
		Segment * c = new Segment(i, r);
		T[l] = b;
		T.insert(T.begin() + l + 1, c);
		return l + 1;
	}
}

void Insert (int i, int x) {
	a[n++] = x;
	int j = split(i);
	T.insert(T.begin() + j, new Segment(n - 1, n));
}

void Erase (int i) {
	int j = split(i);
	split(i + 1);
	T.erase(T.begin() + j);
}

int Count (int l, int r, int x) {
	l = split(l);
	r = split(r + 1);
	int res = 0;
	while (l <= r) 
		res += T[l++]->get(x);
	return res;
}
bool query (char c) {
	return (c == '+') || (c == '-') || (c == '?');
}

void rebuild () {
	int k = (int)sqrt((double)n);
	for (int i = 0; i < n; i += k)
		T.push_back(new Segment(i, min(i + k, n)));
}*/

/*unsigned int a, b;
unsigned int cur = 0;
unsigned int nextRand() {
	cur = cur * a + b;
	return cur >> 8;
}

ll getmod(ll a) {
	if (a >= (1LL << 32))
		a -= (1LL << 32);
	return a % (1LL << 32);
}

int mul[maxn];
int add[maxn];

struct fenwick {


	void update(unsigned int left, unsigned int right, unsigned int by) {
		upd(left, by, -by * (left - 1));
		upd(right, -by, by * right);
	}

	void upd(unsigned int at, int curmul, int curadd) {
		while (at <= maxn) {
			mul[at] = getmod(mul[at] + curmul);
			add[at] = getmod(add[at] + curadd);
			at += at & -at;
		}
	}

	ll get(unsigned int at) {
		ll curmul = 0;
		ll curadd = 0;
		int start = at;
		while (at > 0) {
			curmul = getmod(curmul + mul[at]);
			curadd = getmod(curadd + add[at]);
			at -= at & -at;
		}
		return getmod(((curmul * start) % (1LL << 32)) + curadd);
	}

	ll get(unsigned int l, unsigned int r) {
		return getmod(getmod(get(r) - get(l - 1)) + (1LL << 32));
	}
} F;*/

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	/*int n, m;
	scanf("%d%d", &n, &m);
	cin >> a >> b;
	for (int i = 0; i < n; i++) {
		unsigned int add = nextRand();
		unsigned int l = nextRand() + 1;
		unsigned int r = nextRand() + 1;
		if (l > r) swap(l, r);
		F.update(l, r, add);
	}
	ll answer = 0;
	for (int i = 0; i < m; i++) {
		unsigned int l = nextRand() + 1;
		unsigned int r = nextRand() + 1;
		if (l > r) swap(l, r);
		ll cur = F.get(l, r);
		answer = getmod(cur + answer);
	}
	printf("%lld\n", answer);*/


	/*cin >> n;
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);
	getchar();

	rebuild();

	char c;
	while (query(c = getchar())) {
		if (c == '+') {
			int i, x;
			scanf("%d%d", &i, &x);
			Insert(i, x);
		}
		if (c == '-') {
			int i;
			scanf("%d", &i);
			Erase(i);
		}
		if (c == '?') {
			int l, r, x;	
			scanf("%d%d%d", &l, &r, &x);
			printf("%d\n", Count(l, r, x));
		}
		if (sz(T) >= 3*(int)sqrt((double)n))
			rebuild();
		getchar();
	}*/

	int n;
	cin >> n;
	vector <ll> v(n);
	for (int i = 0; i < n; i++)
		scanf("%lld", &v[i]);

	vector <ll> vright (n), vleft (n);
	vector <ll> s;
	for (int i = 0; i < n; i++) {
		if (s.empty()) {
			s.push_back(i);
			continue;
		}
		while (!s.empty() && (v[i] < v[s.back()])) {
			int cur = s.back();
			s.pop_back();
			vright[cur] = i - 1;
		}
		s.push_back(i);
	}
	while (!s.empty()) {
		int cur = s.back();
		s.pop_back();
		vright[cur] = n - 1;
	}

	//--------left
	for (int i = n - 1; i >= 0; i--) {
		if (s.empty()) {
			s.push_back(i);
			continue;
		}
		while (!s.empty() && (v[i] < v[s.back()])) {
			int cur = s.back();
			s.pop_back();
			vleft[cur] = i + 1;
		}
		s.push_back(i);
	}
	while (!s.empty()) {
		int cur = s.back();
		s.pop_back();
		vleft[cur] = 0;
	}


	ll sum = 0;
	for (int i = 0; i < n; i++) {
		ll all = (vright[i] - vleft[i] + 1)*(vright[i] - vleft[i] + 2)/2;
		ll badl = ((i - 1) - vleft[i] + 1)*((i - 1) - vleft[i] + 2)/2;
		ll badr = (vright[i] - (i + 1) + 1)*(vright[i] - (i + 1) + 2)/2;
		sum += (all - badl - badr)*v[i];
	}
	printf("%lld", sum);
	return 0;
}