#include <iostream>
#include <set>
#include <cstring>
#include <cstdio>
#include <vector>
using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
template <class T> int size(const T &x) { return x.size(); }


int INF = 2147483647;

int main() {
    int n;
    scanf("%d\n", &n);
    vector<int> arr(n);
    for (int i = 0; i< n; i++){
        scanf("%d", &arr[i]);
    }

    int *smallprev = new int[n];
    int *smallnxt = new int[n];
    for (int i = 0; i < n; i++) {
        smallprev[i] = INF;
        smallnxt[i] = INF;
    }

    set<ii> need;
    for (int i = n - 1; i >= 0; i--) {
        //cout << arr[i] << ":" << endl;
        set<ii>::iterator it = need.lower_bound(ii(arr[i], i));
        while (it != need.end()) {
            smallprev[it->second] = i;
            //cout << it->first << endl;
            set<ii>::iterator jt = it;
            jt++;
            need.erase(it);
            it = jt;
        }

        need.insert(ii(arr[i], i));
    }

    need.clear();

    for (int i = 0; i < n; i++) {
        //cout << arr[i] << ":" << endl;
        set<ii>::iterator it = need.lower_bound(ii(arr[i], i));
        while (it != need.end()) {
            smallnxt[it->second] = i;
            //cout << it->first << endl;
            set<ii>::iterator jt = it;
            jt++;
            need.erase(it);
            it = jt;
        }

        need.insert(ii(arr[i], i));
    }

    ll sum = 0;
    for (int i = 0; i < n; i++) {
        int a = smallprev[i],
            b = smallnxt[i];

        if (a == INF) a = -1;
        if (b == INF) b = n;

        a++;
        b--;

        int lposs = i - a + 1;
        int rposs = b - i + 1;

        sum += (ll)arr[i] * lposs * rposs;

        //printf("%d %d %d\n", arr[i], smallprev[i], smallnxt[i]);
    }

    cout << sum << endl;

    return 0;
}

