#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>

#define TASK "task"
#define MOD (1LL << 32LL)

typedef long long ll;
typedef long double ld;

using namespace std;

int arr[1<<24], pSum[1<<24], addAt[1<<24];
ll m, q;
unsigned int a, b;
unsigned int cur = 0;

unsigned int nextRand()
{
	cur = (cur * a) + b;
	return cur >> 8;
}

int main() {
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);

	cin >> m >> q >> a >> b;

	for (int i = 0; i < m; i++)
	{
		int add = nextRand();
		int l = nextRand();
		int r = nextRand();

		if (l > r)
			swap(l, r);

		addAt[l] = (addAt[l] + add) % MOD;
		if (r + 1 < (1 << 24))
			addAt[r+1] = (addAt[r+1] - add) % MOD;

	}

	ll curAdd = 0;
	for (int i = 0; i < (1 << 24); i++)
	{
		curAdd = (curAdd + addAt[i]) % MOD;
		arr[i] = curAdd;

		if (i == 0)
			pSum[i] = arr[i];
		else
			pSum[i] = (pSum[i-1] + arr[i]) % MOD;

	}

	ll totSum = 0;

	for (int i = 0; i < q; i++)
	{
		int l = nextRand();
		int r = nextRand();

		if (l > r)
			swap(l, r);

		if (l == 0)
			totSum = (totSum + pSum[r]) % MOD;
		else
			totSum = (totSum + pSum[r] - pSum[l-1]) % MOD;
	}

	while (totSum < 0)
		totSum += MOD;

	cout << totSum << endl;

	return 0;
}