#include <vector>
#include <iostream>
#include <utility>
#include <cstring>
#include <fstream>

#define inf (1<<30)

using namespace std;

ifstream fin ("fastadd.in");
ofstream fout ("fastadd.out");

unsigned int a,b,cur = 0;

unsigned int nextrand()
{
    cur = cur*a + b;
    return (cur>>8);
}

unsigned int mars[(1<<24)+8],sum[(1<<24)+8],m,q,add,l,r,answer;

int main ()
{
    fin>>m>>q>>a>>b;

    for (int i=1; i<=m; ++i)
    {
        add = nextrand();
        l = nextrand ();
        r = nextrand ();
        if (l > r)
        swap (l,r);
        mars[l] += add;
        mars[r+1] -= add;
    }

    for (int i=1; i<(1<<24); ++i)
    {
        mars[i] += mars[i-1];
    }

    sum[0] = mars[0];

    for (int i=1; i<(1<<24); ++i)
    {
        sum[i] = sum[i-1] + mars[i];
    }

    for (int i=1; i<=q; ++i)
    {
        l = nextrand();
        r = nextrand();

        if (l > r)
          swap (l,r);
        if (l == 0)
         answer += sum[r];
        else answer += sum[r] - sum[l-1];
    }

    fout<<answer;
}
