#include <vector>
#include <iostream>
#include <utility>
#include <cstring>
#include <fstream>
#include <stack>

#define inf (1<<30)

using namespace std;

ifstream fin ("minsum.in");
ofstream fout ("minsum.out");

int a[100010],n;
stack <pair<int,int> > S;
long long answer;

int main ()
{
    fin>>n;

    for (int i=1; i<=n; ++i)
    {
        fin>>a[i];
    }

    S.push (make_pair (-inf,0));
    long long sum = 0;

    for (int i=1; i<=n; ++i)
    {
        while (a[i] < S.top().first)
        {
            pair<int,int> ret = S.top();
            S.pop ();

            sum -= 1LL*ret.first * (ret.second - S.top().second);
        }

        sum += 1LL* a[i] * (i-S.top().second);
        S.push (make_pair(a[i],i));
        answer += sum;
    }

    fout<<answer;
}
